diff -uNr ./freebios2/src/arch/i386/config/make.base ../freebios2/src/arch/i386/config/make.base
--- ./freebios2/src/arch/i386/config/make.base	2003-04-25 23:20:51.000000000 -0400
+++ ../freebios2/src/arch/i386/config/make.base	2003-06-20 00:39:14.000000000 -0400
@@ -33,7 +33,8 @@
 addaction linuxbios.rom echo $$size ; \
 addaction linuxbios.rom dd if=linuxbios.strip of=linuxbios.rom bs=1 seek=`expr $(ROM_IMAGE_SIZE) - $$size`
 
-makerule payload.block : $(if $(PAYLOAD),$(PAYLOAD), /dev/null) ; perl -e '@stats=stat("$<"); $$sz=$$stats[7]; print "\xff" x ($(PAYLOAD_SIZE) - $$sz);' | cat $< - > $@
+#makerule payload.block : $(if $(PAYLOAD),$(PAYLOAD), /dev/null) ; perl -e '@stats=stat("$<"); $$sz=$$stats[7]; print "\xff" x ($(PAYLOAD_SIZE) - $$sz);' | cat $< - > $@
+makerule payload.block : $(if $(PAYLOAD),$(PAYLOAD), linux.bin.gz) ; dd conv=sync bs=$(PAYLOAD_SIZE) if=$< of=$@
 
 addaction clean rm -f romimage payload.*
 
diff -uNr ./freebios2/src/boot/hardwaremain.c ../freebios2/src/boot/hardwaremain.c
--- ./freebios2/src/boot/hardwaremain.c	2003-07-22 00:09:56.000000000 -0400
+++ ../freebios2/src/boot/hardwaremain.c	2003-07-23 04:34:02.000000000 -0400
@@ -36,7 +36,7 @@
 #include <device/device.h>
 #include <device/pci.h>
 #include <delay.h>
-#if 0
+#if 1
 #include <part/mainboard.h>
 #endif
 #if 0
@@ -44,6 +44,7 @@
 #endif
 #include <smp/atomic.h>
 #include <boot/elf.h>
+#include <arch/smp/mpspec.h>
 
 
 #ifndef CONFIG_MAX_PHYSICAL_CPUS
@@ -210,6 +211,12 @@
 	/* make certain we are the only cpu running in linuxBIOS */
 	wait_for_other_cpus();
 
+	//BY LYH
+        // generic mainboard fixup
+        mainboard_fixup();
+	//BY LYH END
+
+
 	/* Now that we have collected all of our information
 	 * write our configuration tables.
 	 */
diff -uNr ./freebios2/src/include/device/pci_ids.h ../freebios2/src/include/device/pci_ids.h
--- ./freebios2/src/include/device/pci_ids.h	2003-05-19 15:16:17.000000000 -0400
+++ ../freebios2/src/include/device/pci_ids.h	2003-07-08 20:27:23.000000000 -0400
@@ -411,6 +411,10 @@
 #define PCI_DEVICE_ID_AMD_8111_SMB      0x746a
 #define PCI_DEVICE_ID_AMD_8111_ACPI     0x746b
 
+#define PCI_DEVICE_ID_AMD_8111_USB2     0x7463
+#define PCI_DEVICE_ID_AMD_8131_PCIX	0x7450
+#define PCI_DEVICE_ID_AMD_8131_IOAPIC   0x7451
+
 #define PCI_VENDOR_ID_TRIDENT		0x1023
 #define PCI_DEVICE_ID_TRIDENT_4DWAVE_DX	0x2000
 #define PCI_DEVICE_ID_TRIDENT_4DWAVE_NX	0x2001
diff -uNr ./freebios2/src/include/part/mainboard.h ../freebios2/src/include/part/mainboard.h
--- ./freebios2/src/include/part/mainboard.h	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/include/part/mainboard.h	2003-06-13 17:25:07.000000000 -0400
@@ -0,0 +1,18 @@
+#ifndef PART_MAINBOARD_H
+#define PART_MAINBOARD_H
+
+void mainboard_fixup(void);
+
+#ifdef FINAL_MAINBOARD_FIXUP
+void final_mainboard_fixup(void);
+#else
+#  define final_mainboard_fixup() do {} while(0)
+#endif /* FINAL_MAINBOARD_FIXUP */
+
+#ifdef HAVE_MAINBOARD_CPU_FIXUP
+void mainboard_cpu_fixup(int);
+#else
+#  define mainboard_cpu_fixup(x) do {} while(0)
+#endif /* HAVE_MAINBOARD_CPU_FIXUP */
+
+#endif /* PART_MAINBOARD_H */
diff -uNr ./freebios2/src/mainboard/tyan/s2880/auto.c ../freebios2/src/mainboard/tyan/s2880/auto.c
--- ./freebios2/src/mainboard/tyan/s2880/auto.c	2003-07-21 16:13:43.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/auto.c	2003-07-24 18:00:47.000000000 -0400
@@ -1,437 +1,211 @@
 #define ASSEMBLY 1
 #include <stdint.h>
 #include <device/pci_def.h>
-#include "arch/romcc_io.h"
+#include <cpu/p6/apic.h>
+#include <arch/io.h>
+#include <arch/romcc_io.h>
 #include "pc80/serial.c"
 #include "arch/i386/lib/console.c"
 #include "ram/ramtest.c"
 #include "northbridge/amd/amdk8/early_ht.c"
 #include "southbridge/amd/amd8111/amd8111_early_smbus.c"
 #include "northbridge/amd/amdk8/raminit.h"
-/*
-#warning "FIXME move these delay functions somewhere more appropriate"
-#warning "FIXME use the apic timer instead it needs no calibration on an Opteron it runs at 200Mhz"
-static void print_clock_multiplier(void)
-{
-        msr_t msr;
-        print_debug("clock multipler: 0x");
-        msr = rdmsr(0xc0010042);
-        print_debug_hex32(msr.lo & 0x3f);
-        print_debug(" = 0x");
-        print_debug_hex32(((msr.lo & 0x3f) + 8) * 100);
-        print_debug("Mhz\r\n");
-}
+#include "cpu/k8/apic_timer.c"
+#include "lib/delay.c"
+#include "cpu/p6/boot_cpu.c"
+#include "northbridge/amd/amdk8/reset_test.c"
+#include "debug.c"
 
-static unsigned usecs_to_ticks(unsigned usecs)
+static void memreset_setup(void)
 {
-#warning "FIXME make usecs_to_ticks work properly"
-#if 1
-        return usecs *2000;
-#else
-        // This can only be done if cpuid says fid changing is supported
-        // I need to look up the base frequency another way for other
-        // cpus.  Is it worth dedicating a global register to this?
-        // Are the PET timers useable for this purpose?
-         
-        msr_t msr;
-        msr = rdmsr(0xc0010042);
-        return ((msr.lo & 0x3f) + 8) * 100 *usecs;
-#endif
+	/* Set the memreset low */
+	outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 28);
+	/* Ensure the BIOS has control of the memory lines */
+	outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 29);
 }
 
-static void init_apic_timer(void)
+static void memreset(int controllers, const struct mem_controller *ctrl)
 {
-        volatile uint32_t *apic_reg = (volatile uint32_t *)0xfee00000;
-        uint32_t start, end;
-        // Set the apic timer to no interrupts and periodic mode 
-        apic_reg[0x320 >> 2] = (1 << 17)|(1<< 16)|(0 << 12)|(0 << 0);
-        // Set the divider to 1, no divider 
-        apic_reg[0x3e0 >> 2] = (1 << 3) | 3;
-        // Set the initial counter to 0xffffffff 
-        apic_reg[0x380 >> 2] = 0xffffffff;
+	udelay(800);
+	/* Set memreset_high */
+	outb((0<<7)|(0<<6)|(0<<5)|(0<<4)|(1<<2)|(1<<0), SMBUS_IO_BASE + 0xc0 + 28);
+	udelay(90);
 }
 
-static void udelay(unsigned usecs)
+static unsigned int generate_row(uint8_t node, uint8_t row, uint8_t maxnodes)
 {
-#if 1
-        uint32_t start, ticks;
-        tsc_t tsc;
-        // Calculate the number of ticks to run for 
-        ticks = usecs_to_ticks(usecs);
-        // Find the current time 
-        tsc = rdtsc();
-        start = tsc.lo;
-        do {
-                tsc = rdtsc();
-        } while((tsc.lo - start) < ticks);
-#else
-        volatile uint32_t *apic_reg = (volatile uint32_t *)0xfee00000;
-        uint32_t start, value, ticks;
-        // Calculate the number of ticks to run for 
-        ticks = usecs * 200;
-        start = apic_reg[0x390 >> 2];
-        do {
-                value = apic_reg[0x390 >> 2];
-        } while((start - value) < ticks);
-#endif
-}
+	/* Routing Table Node i 
+	 *
+	 * F0: 0x40, 0x44, 0x48, 0x4c, 0x50, 0x54, 0x58, 0x5c 
+	 *  i:    0,    1,    2,    3,    4,    5,    6,    7
+	 *
+	 * [ 0: 3] Request Route
+	 *     [0] Route to this node
+	 *     [1] Route to Link 0
+	 *     [2] Route to Link 1
+	 *     [3] Route to Link 2
+	 * [11: 8] Response Route
+	 *     [0] Route to this node
+	 *     [1] Route to Link 0
+	 *     [2] Route to Link 1
+	 *     [3] Route to Link 2
+	 * [19:16] Broadcast route
+	 *     [0] Route to this node
+	 *     [1] Route to Link 0
+	 *     [2] Route to Link 1
+	 *     [3] Route to Link 2
+	 */
 
-static void mdelay(unsigned msecs)
-{
-        int i;
-        for(i = 0; i < msecs; i++) {
-                udelay(1000);
-        }
-}
+	uint32_t ret=0x00010101; /* default row entry */
 
-static void delay(unsigned secs)
-{
-        int i;
-        for(i = 0; i < secs; i++) {
-                mdelay(1000);
-        }
-}
+	static const unsigned int rows_2p[2][2] = {
+		{ 0x00050101, 0x00010404 },
+		{ 0x00010404, 0x00050101 }
+	};
 
-static void memreset_setup(const struct mem_controller *ctrl)
-{
-        // Set the memreset low 
-        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 28);
-        // Ensure the BIOS has control of the memory lines 
-        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 29);
-        print_debug("memreset lo\r\n");
+	if(maxnodes>2) {
+		print_debug("this mainboard is only designed for 2 cpus\r\n");
+		maxnodes=2;
+	}
+
+
+	if (!(node>=maxnodes || row>=maxnodes)) {
+		ret=rows_2p[node][row];
+	}
+
+	return ret;
 }
 
-static void memreset(const struct mem_controller *ctrl)
+static inline int spd_read_byte(unsigned device, unsigned address)
 {
-        udelay(800);
-        // Set memreset_high 
-        outb((0<<7)|(0<<6)|(0<<5)|(0<<4)|(1<<2)|(1<<0), SMBUS_IO_BASE + 0xc0 + 28);
-        print_debug("memreset hi\r\n");
-        udelay(50);
+	return smbus_read_byte(device, address);
 }
-*/              
+
+#include "northbridge/amd/amdk8/cpu_ldtstop.c"
+#include "southbridge/amd/amd8111/amd8111_ldtstop.c"
 
 #include "northbridge/amd/amdk8/raminit.c"
 #include "northbridge/amd/amdk8/coherent_ht.c"
 #include "sdram/generic_sdram.c"
 
-#define NODE_ID         0x60
-#define HT_INIT_CONTROL 0x6c
- 
-#define HTIC_ColdR_Detect  (1<<4)
-#define HTIC_BIOSR_Detect  (1<<5)
-#define HTIC_INIT_Detect   (1<<6)
- 
-#define APIC_DEFAULT_BASE 0xfee00000
-
-#define APIC_ID         0x020
-
-static int boot_cpu(void)
+static void enable_lapic(void)
 {
-	volatile unsigned long *local_apic;
-	unsigned long apic_id;
-	int bsp;
-	int apicEn;
 	msr_t msr;
 	msr = rdmsr(0x1b);
-	bsp = !!(msr.lo & (1 << 8));
-	apicEn = !!(msr.lo & (1<<11));
-	if(apicEn) {
-		print_debug("apic enabled\r\n");
-	} else {
-		msr.lo |= (1<<11);
-		wrmsr(0x1b,msr);
-	}
-        apic_id = *((volatile unsigned long *)(APIC_DEFAULT_BASE+APIC_ID));
-        print_debug("apic_id: ");
-        print_debug_hex32(apic_id>>24);
-        print_debug("\r\n");
-	
-	if (bsp) {
-		print_debug("Bootstrap cpu\r\n");
-	} else {
-                print_debug("Application processor\r\n");
-	//	asm("hlt"); // move to end before halt should notify BSP
-		   // if you start AP in coherent.c you can just stop it here	
-        }
-
-	return bsp;
+	msr.hi &= 0xffffff00;
+	msr.lo &= 0x000007ff;
+	msr.lo |= APIC_DEFAULT_BASE | (1 << 11);
+	wrmsr(0x1b, msr);
 }
 
-static int cpu_init_detected(void)
+static void stop_this_cpu(void)
 {
-	unsigned long dcl;
-	int cpu_init;
+	unsigned apicid;
+	apicid = apic_read(APIC_ID) >> 24;
 
-	unsigned long htic;
+	/* Send an APIC INIT to myself */
+	apic_write(APIC_ICR2, SET_APIC_DEST_FIELD(apicid));
+	apic_write(APIC_ICR, APIC_INT_LEVELTRIG | APIC_INT_ASSERT | APIC_DM_INIT);
+	/* Wait for the ipi send to finish */
+	apic_wait_icr_idle();
 
-	htic = pci_read_config32(PCI_DEV(0, 0x18, 0), HT_INIT_CONTROL);
-#if 0
-	print_debug("htic: ");
-	print_debug_hex32(htic);
-	print_debug("\r\n");
+	/* Deassert the APIC INIT */
+	apic_write(APIC_ICR2, SET_APIC_DEST_FIELD(apicid));
+	apic_write(APIC_ICR,  APIC_INT_LEVELTRIG | APIC_DM_INIT);
+	/* Wait for the ipi send to finish */
+	apic_wait_icr_idle();
 
-	if (!(htic & HTIC_ColdR_Detect)) {
-		print_debug("Cold Reset.\r\n");
+	/* If I haven't halted spin forever */
+	for(;;) {
+		hlt();
 	}
-	if ((htic & HTIC_ColdR_Detect) && !(htic & HTIC_BIOSR_Detect)) {
-		print_debug("BIOS generated Reset.\r\n");
-	}
-	if (htic & HTIC_INIT_Detect) {
-		print_debug("Init event.\r\n");
-	}
-#endif
-	cpu_init = (htic & HTIC_INIT_Detect);
-	if (cpu_init) {
-		print_debug("CPU INIT Detected.\r\n");
-	}
-	return cpu_init;
 }
-/*
-static void print_debug_pci_dev(unsigned dev)
-{
-        print_debug("PCI: ");
-        print_debug_hex8((dev >> 16) & 0xff);
-        print_debug_char(':');
-        print_debug_hex8((dev >> 11) & 0x1f);
-        print_debug_char('.');
-        print_debug_hex8((dev >> 8) & 7);
-}
-
-
-static void print_pci_devices(void)
-{
-	device_t dev;
-	for(dev = PCI_DEV(0, 0, 0); 
-		dev <= PCI_DEV(0, 0x1f, 0x7); 
-		dev += PCI_DEV(0,0,1)) {
-		uint32_t id;
-		id = pci_read_config32(dev, PCI_VENDOR_ID);
-		if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
-			(((id >> 16) & 0xffff) == 0xffff) ||
-			(((id >> 16) & 0xffff) == 0x0000)) {
-			continue;
-		}
-                print_debug_pci_dev(dev);
-                print_debug("\r\n");
-	}
-}
-*/
-/*
-static void dump_pci_device(unsigned dev)
-{
-        int i;
-        print_debug_pci_dev(dev);
-        print_debug("\r\n");
-
-        for(i = 0; i <= 255; i++) {
-                unsigned char val;
-                if ((i & 0x0f) == 0) {
-                        print_debug_hex8(i);
-                        print_debug_char(':');
-                }
-                val = pci_read_config8(dev, i);
-                print_debug_char(' ');
-                print_debug_hex8(val);
-                if ((i & 0x0f) == 0x0f) {
-                        print_debug("\r\n");
-                }
-        }
-}
-static void dump_pci_devices(void)
-{
-        device_t dev;
-        for(dev = PCI_DEV(0, 0, 0);
-                dev <= PCI_DEV(0, 0x1f, 0x7);
-                dev += PCI_DEV(0,0,1)) {
-                uint32_t id;
-                id = pci_read_config32(dev, PCI_VENDOR_ID);
-                if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
-                        (((id >> 16) & 0xffff) == 0xffff) ||
-                        (((id >> 16) & 0xffff) == 0x0000)) {
-                        continue;
-                }
-                dump_pci_device(dev);
-        }
-}
-
-
-
-static void dump_spd_registers(const struct mem_controller *ctrl)
-{
-        int i;
-        print_debug("\r\n");
-        for(i = 0; i < 4; i++) {
-                unsigned device;
-                device = ctrl->channel0[i];
-                if (device) {
-                        int j;
-                        print_debug("dimm: ");
-                        print_debug_hex8(i);
-                        print_debug(".0: ");
-                        print_debug_hex8(device);
-                        for(j = 0; j < 256; j++) {
-                                int status;
-                                unsigned char byte;
-                                if ((j & 0xf) == 0) {
-                                        print_debug("\r\n");
-                                        print_debug_hex8(j);
-                                        print_debug(": ");
-                                }
-                                status = smbus_read_byte(device, j);
-                                if (status < 0) {
-                                        print_debug("bad device\r\n");
-     
-                                        break;
-                                }
-                                byte = status & 0xff;
-                                print_debug_hex8(byte);
-                                print_debug_char(' ');
-                        }
-                        print_debug("\r\n");
-                }
-                device = ctrl->channel1[i];
-                if (device) {
-                        int j;
-                        print_debug("dimm: ");
-                        print_debug_hex8(i);
-                        print_debug(".1: ");
-                        print_debug_hex8(device);
-                        for(j = 0; j < 256; j++) {
-                                int status;
-                                unsigned char byte;
-                                if ((j & 0xf) == 0) {
-                                        print_debug("\r\n");
-                                        print_debug_hex8(j);
-                                        print_debug(": ");
-                                }
-                                status = smbus_read_byte(device, j);
-      
-                                if (status < 0) {
-                                        print_debug("bad device\r\n");
-                                        break;
-                                }
-                                byte = status & 0xff;
-                                print_debug_hex8(byte);
-                                print_debug_char(' ');
-                        }
-                        print_debug("\r\n");
-                }
-        }
-}
-
-*/
-
-
-
+#define FIRST_CPU  1
+#define SECOND_CPU 1
+#define TOTAL_CPUS (FIRST_CPU + SECOND_CPU)
 static void main(void)
 {
-        static const struct mem_controller cpu0 = {
-                .f0 = PCI_DEV(0, 0x18, 0),
-                .f1 = PCI_DEV(0, 0x18, 1),
-                .f2 = PCI_DEV(0, 0x18, 2),
-                .f3 = PCI_DEV(0, 0x18, 3),
-                .channel0 = { (0xa<<3)|0, (0xa<<3)|2, 0, 0 },
-                .channel1 = { (0xa<<3)|1, (0xa<<3)|3, 0, 0 },
-        };
-        static const struct mem_controller cpu1 = {
-                .f0 = PCI_DEV(0, 0x19, 0),
-                .f1 = PCI_DEV(0, 0x19, 1),
-                .f2 = PCI_DEV(0, 0x19, 2),
-                .f3 = PCI_DEV(0, 0x19, 3),
-                .channel0 = { (0xa<<3)|4, (0xa<<3)|6, 0, 0 },
-                .channel1 = { (0xa<<3)|5, (0xa<<3)|7, 0, 0 },
-        };
-
- //               device_t dev;
- //               unsigned where;
-                unsigned long reg;
-//                dev = PCI_ADDR(0, 0x19, 0, 0x6C) & ~0xff;
-//                where = PCI_ADDR(0, 0x19, 0, 0x6C) & 0xff;
-#if 0
-                init_apic_timer();
+	/*
+	 * GPIO28 of 8111 will control H0_MEMRESET_L
+	 * GPIO29 of 8111 will control H1_MEMRESET_L
+	 */
+	static const struct mem_controller cpu[] = {
+#if FIRST_CPU
+		{
+			.node_id = 0,
+			.f0 = PCI_DEV(0, 0x18, 0),
+			.f1 = PCI_DEV(0, 0x18, 1),
+			.f2 = PCI_DEV(0, 0x18, 2),
+			.f3 = PCI_DEV(0, 0x18, 3),
+			.channel0 = { (0xa<<3)|0, (0xa<<3)|2, 0, 0 },
+			.channel1 = { (0xa<<3)|1, (0xa<<3)|3, 0, 0 },
+		},
 #endif
-  
+#if SECOND_CPU
+		{
+			.node_id = 1,
+			.f0 = PCI_DEV(0, 0x19, 0),
+			.f1 = PCI_DEV(0, 0x19, 1),
+			.f2 = PCI_DEV(0, 0x19, 2),
+			.f3 = PCI_DEV(0, 0x19, 3),
+			.channel0 = { (0xa<<3)|4, (0xa<<3)|6, 0, 0 },
+			.channel1 = { (0xa<<3)|5, (0xa<<3)|7, 0, 0 },
+		},
+#endif
+	};
+	if (cpu_init_detected()) {
+		asm("jmp __cpu_reset");
+	}
+	enable_lapic();
+	init_timer();
+	if (!boot_cpu() ) {
+		notify_bsp_ap_is_stopped();
+		stop_this_cpu();
+	}
 	uart_init();
 	console_init();
-	if (boot_cpu() && !cpu_init_detected()) {
-		setup_default_resource_map();
-		setup_coherent_ht_domain();
-		enumerate_ht_chain();
-//		print_pci_devices();
-		enable_smbus();
-//		sdram_initialize();
- //               dump_spd_registers(&cpu0);
-                sdram_initialize(&cpu0);
- //               dump_spd_registers(&cpu1);
-//                sdram_initialize(&cpu1);
-
-//		dump_pci_device(PCI_DEV(0, 0x18, 2));
+	setup_default_resource_map();
+	setup_coherent_ht_domain();
+	enumerate_ht_chain(0);
+	distinguish_cpu_resets(0);
+	
 #if 0
-		ram_fill(  0x00100000, 0x00180000);
-		ram_verify(0x00100000, 0x00180000);
+	print_pci_devices();
 #endif
-//#ifdef MEMORY_1024MB
-//		ram_fill(  0x00000000, 0x00001000);
-//		ram_verify(0x00000000, 0x00001000);
-//#endif
-//#ifdef MEMROY_512MB
-//		ram_fill(  0x00000000, 0x01ffffff);
-//		ram_verify(0x00000000, 0x01ffffff);
-//#endif
-		                /* Check the first 512M */
-/*                msr_t msr;
-                msr = rdmsr(TOP_MEM);
-                print_debug("TOP_MEM: ");
-                print_debug_hex32(msr.hi);
-                print_debug_hex32(msr.lo);
-                print_debug("\r\n");
-                ram_check(0x00000000, msr.lo);
-  */    	
-/*
-        reg = *((volatile unsigned long *)(APIC_DEFAULT_BASE+APIC_ID));
-        print_debug("bootstrap cpu apic_id: ");
-        print_debug_hex32(reg>>24);
-        print_debug("\r\n");
-*/
+	enable_smbus();
+#if 0
+	dump_spd_registers(&cpu[0]);
+#endif
+	memreset_setup();
+	sdram_initialize(sizeof(cpu)/sizeof(cpu[0]), cpu);
 
-		// Start AP now
-		reg = pci_read_config32(PCI_DEV(0, 0x19, 0), 0x6C);
-		reg &= 0xffffff8c;
-		reg |= 0x00000070;
-		pci_write_config32(PCI_DEV(0, 0x19, 0), 0x6C, reg); //start AP
-                for(;;) {
-                        reg = pci_read_config32(PCI_DEV(0, 0x19, 0), 0x6C);
-                        if((reg & (1<<4))==0) break;  // wait until AP stop
-                }
-                reg |= 1<<4;
-                pci_write_config32(PCI_DEV(0, 0x19, 0), 0x6C, reg);
+#if 0
+	dump_pci_devices();
+#endif
+#if 0
+	dump_pci_device(PCI_DEV(0, 0x18, 2));
+#endif
 
-	}
- else {
-	  // Need to init second cpu's APIC id
-	// It's AP 
- 
-//	apic_write(APIC_ID,(1<<24));
-	reg = *((volatile unsigned long *)(APIC_DEFAULT_BASE+APIC_ID));
-/*	print_debug("applicaton cpu apic_id: ");
-	print_debug_hex32(reg>>24);
+	/* Check all of memory */
+#if 0
+	msr_t msr;
+	msr = rdmsr(TOP_MEM);
+	print_debug("TOP_MEM: ");
+	print_debug_hex32(msr.hi);
+	print_debug_hex32(msr.lo);
 	print_debug("\r\n");
-	if((reg>>24)==7){ // FIXME: Need to read NodeID at first.
-		*((volatile unsigned long *)(APIC_DEFAULT_BASE+APIC_ID))=1<<24;
-	}*/
-	if((reg>>24)!=0) {
-//		before hlt clear the ColdResetbit
-		
-		//notify BSP that AP is stopped
-                reg = pci_read_config32(PCI_DEV(0, 0x19, 0), 0x6C);
-                reg &= ~(1<<4);
-                pci_write_config32(PCI_DEV(0, 0x19, 0),  0x6C, reg);
-
-		asm("hlt");
-	}
-       
-
-	}
-	
+#endif
+/*
+#if 1
+	ram_check(0x00000000, msr.lo);
+#else
+#if TOTAL_CPUS < 2
+	// Check 16MB of memory @ 0
+	ram_check(0x00000000, 0x01000000);
+#else
+	// Check 16MB of memory @ 2GB 
+	ram_check(0x80000000, 0x81000000);
+#endif
+#endif
+*/
 }
diff -uNr ./freebios2/src/mainboard/tyan/s2880/Config ../freebios2/src/mainboard/tyan/s2880/Config
--- ./freebios2/src/mainboard/tyan/s2880/Config	2003-07-21 16:13:43.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/Config	2003-07-24 18:01:01.000000000 -0400
@@ -4,7 +4,7 @@
 arch i386
 cpu k8
 
-option DEBUG=1
+option DEBUG=0
 
 ##
 ## Build our 16 bit and 32 bit linuxBIOS entry code
@@ -31,19 +31,19 @@
 mainboardinit arch/i386/lib/id.inc
 ldscript arch/i386/lib/id.lds
 
+##
+## Setup our mtrrs
+##
+mainboardinit cpu/k8/earlymtrr.inc
+
 ###
 ### This is the early phase of linuxBIOS startup 
 ### Things are delicate and we test to see if we should
 ### failover to another image.
 ###
-option MAX_REBOOT_CNT=2
+option MAX_REBOOT_CNT=1
 ldscript arch/i386/lib/failover.lds USE_FALLBACK_IMAGE
 
-##
-## Setup our mtrrs
-##
-mainboardinit cpu/k8/earlymtrr.inc
-
 
 ##
 ## Only the bootstrap cpu makes it here.
@@ -76,12 +76,15 @@
 ##
 ## Romcc output
 ##
-makerule ./failover.E: $(MAINBOARD)/failover.c; $(CPP) -I$(TOP)/src $(ROMCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/failover.c > ./failover.E
-makerule ./failover.inc: ./romcc ./failover.E ; ./romcc -O -o failover.inc --label-prefix=failover ./failover.E
 
+makerule ./failover.E: $(MAINBOARD)/failover.c; $(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/failover.c > ./failover.E
+makerule ./failover.inc: ./romcc ./failover.E ; ./romcc -O -o failover.inc --label-prefix=failover ./failover.E
 makerule ./auto.E: $(MAINBOARD)/auto.c  ; $(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/auto.c > ./auto.E
-makerule ./auto.inc: ./romcc ./auto.E ; ./romcc -mcpu=k8 -O -o auto.inc --label-prefix=auto ./auto.E
+makerule ./auto.inc: ./romcc ./auto.E ; ./romcc -O -mcpu=k8 -o auto.inc --label-prefix=auto ./auto.E
+mainboardinit cpu/k8/enable_mmx_sse.inc
 mainboardinit ./auto.inc
+mainboardinit cpu/k8/disable_mmx_sse.inc
+
 
 
 ##
@@ -151,8 +154,8 @@
 ##
 ## Delay timer options
 ##
-option CONFIG_UDELAY_TSC=1
-option CONFIG_TSC_X86RDTSC_CALIBRATE_WITH_TIMER2=1
+#option CONFIG_UDELAY_TSC=1
+#option CONFIG_TSC_X86RDTSC_CALIBRATE_WITH_TIMER2=1
 #option CONFIG_UDELAY_TIMER2=1
  
 ##
@@ -284,8 +287,8 @@
 ## Compute the location and size of where this firmware image
 ## (linuxBIOS plus bootloader) will live in the boot rom chip.
 ##
-expr ROM_SECTION_SIZE  =(USE_FALLBACK_IMAGE*65536)+(USE_NORMAL_IMAGE*(ROM_SIZE - 65536))
-expr ROM_SECTION_OFFSET=(USE_FALLBACK_IMAGE*(ROM_SIZE-65536))+(USE_NORMAL_IMAGE*0)
+expr ROM_SECTION_SIZE  =(USE_FALLBACK_IMAGE*98304)+(USE_NORMAL_IMAGE*(ROM_SIZE - 98304))
+expr ROM_SECTION_OFFSET=(USE_FALLBACK_IMAGE*(ROM_SIZE-98304))+(USE_NORMAL_IMAGE*0)
 
 ##
 ## Compute the start location and size size of
@@ -304,8 +307,8 @@
 ## Compute a range of ROM that can cached to speed up linuxBIOS,
 ## execution speed.
 ##
-#expr XIP_ROM_SIZE = 65536
-#expr XIP_ROM_BASE = _ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE
+expr XIP_ROM_SIZE = 98304 
+expr XIP_ROM_BASE = _ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE
 #option XIP_ROM_SIZE=65536
 #option XIP_ROM_BASE=0xffff0000
 
diff -uNr ./freebios2/src/mainboard/tyan/s2880/debug.c ../freebios2/src/mainboard/tyan/s2880/debug.c
--- ./freebios2/src/mainboard/tyan/s2880/debug.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2880/debug.c	2003-07-21 19:52:25.000000000 -0400
@@ -0,0 +1,127 @@
+
+static void print_debug_pci_dev(unsigned dev)
+{
+	print_debug("PCI: ");
+	print_debug_hex8((dev >> 16) & 0xff);
+	print_debug_char(':');
+	print_debug_hex8((dev >> 11) & 0x1f);
+	print_debug_char('.');
+	print_debug_hex8((dev >> 8) & 7);
+}
+
+static void print_pci_devices(void)
+{
+	device_t dev;
+	for(dev = PCI_DEV(0, 0, 0); 
+		dev <= PCI_DEV(0, 0x1f, 0x7); 
+		dev += PCI_DEV(0,0,1)) {
+		uint32_t id;
+		id = pci_read_config32(dev, PCI_VENDOR_ID);
+		if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0x0000)) {
+			continue;
+		}
+		print_debug_pci_dev(dev);
+		print_debug("\r\n");
+	}
+}
+
+static void dump_pci_device(unsigned dev)
+{
+	int i;
+	print_debug_pci_dev(dev);
+	print_debug("\r\n");
+	
+	for(i = 0; i <= 255; i++) {
+		unsigned char val;
+		if ((i & 0x0f) == 0) {
+			print_debug_hex8(i);
+			print_debug_char(':');
+		}
+		val = pci_read_config8(dev, i);
+		print_debug_char(' ');
+		print_debug_hex8(val);
+		if ((i & 0x0f) == 0x0f) {
+			print_debug("\r\n");
+		}
+	}
+}
+
+static void dump_pci_devices(void)
+{
+	device_t dev;
+	for(dev = PCI_DEV(0, 0, 0); 
+		dev <= PCI_DEV(0, 0x1f, 0x7); 
+		dev += PCI_DEV(0,0,1)) {
+		uint32_t id;
+		id = pci_read_config32(dev, PCI_VENDOR_ID);
+		if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0x0000)) {
+			continue;
+		}
+		dump_pci_device(dev);
+	}
+}
+
+static void dump_spd_registers(const struct mem_controller *ctrl)
+{
+	int i;
+	print_debug("\r\n");
+	for(i = 0; i < 4; i++) {
+		unsigned device;
+		device = ctrl->channel0[i];
+		if (device) {
+			int j;
+			print_debug("dimm: "); 
+			print_debug_hex8(i); 
+			print_debug(".0: ");
+			print_debug_hex8(device);
+			for(j = 0; j < 256; j++) {
+				int status;
+				unsigned char byte;
+				if ((j & 0xf) == 0) {
+					print_debug("\r\n");
+					print_debug_hex8(j);
+					print_debug(": ");
+				}
+				status = smbus_read_byte(device, j);
+				if (status < 0) {
+					print_debug("bad device\r\n");
+					break;
+				}
+				byte = status & 0xff;
+				print_debug_hex8(byte);
+				print_debug_char(' ');
+			}
+			print_debug("\r\n");
+		}
+		device = ctrl->channel1[i];
+		if (device) {
+			int j;
+			print_debug("dimm: "); 
+			print_debug_hex8(i); 
+			print_debug(".1: ");
+			print_debug_hex8(device);
+			for(j = 0; j < 256; j++) {
+				int status;
+				unsigned char byte;
+				if ((j & 0xf) == 0) {
+					print_debug("\r\n");
+					print_debug_hex8(j);
+					print_debug(": ");
+				}
+				status = smbus_read_byte(device, j);
+				if (status < 0) {
+					print_debug("bad device\r\n");
+					break;
+				}
+				byte = status & 0xff;
+				print_debug_hex8(byte);
+				print_debug_char(' ');
+			}
+			print_debug("\r\n");
+		}
+	}
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2880/failover.c ../freebios2/src/mainboard/tyan/s2880/failover.c
--- ./freebios2/src/mainboard/tyan/s2880/failover.c	2003-07-21 16:13:43.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/failover.c	2003-07-21 19:52:59.000000000 -0400
@@ -2,25 +2,37 @@
 #include <stdint.h>
 #include <device/pci_def.h>
 #include <device/pci_ids.h>
+#include <arch/io.h>
 #include "arch/romcc_io.h"
 #include "pc80/mc146818rtc_early.c"
 #include "southbridge/amd/amd8111/amd8111_enable_rom.c"
 #include "northbridge/amd/amdk8/early_ht.c"
-
-
+#include "cpu/p6/boot_cpu.c"
+#include "northbridge/amd/amdk8/reset_test.c"
 
 static void main(void)
 {
-	if (do_normal_boot()) {
-		/* Nothing special needs to be done to find bus 0 */
-
-		/* Allow the HT devices to be found */
-		enumerate_ht_chain();
-
-		/* Setup the 8111 */
-		amd8111_enable_rom();
-
-		/* Jump to the normal image */
+	/* Nothing special needs to be done to find bus 0 */
+	/* Allow the HT devices to be found */
+	enumerate_ht_chain(0);
+
+	/* Setup the 8111 */
+	amd8111_enable_rom();
+
+	/* Is this a cpu reset? */
+	if (cpu_init_detected()) {
+		if (last_boot_normal()) {
+			asm("jmp __normal_image");
+		} else {
+			asm("jmp __cpu_reset");
+		}
+	}
+	/* Is this a secondary cpu? */
+	else if (!boot_cpu() && last_boot_normal()) {
+		asm("jmp __normal_image");
+	}
+	/* This is the primary cpu how should I boot? */
+	else if (do_normal_boot()) {
 		asm("jmp __normal_image");
 	}
 }
diff -uNr ./freebios2/src/mainboard/tyan/s2880/static_devices.c ../freebios2/src/mainboard/tyan/s2880/static_devices.c
--- ./freebios2/src/mainboard/tyan/s2880/static_devices.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2880/static_devices.c	2003-06-24 20:25:02.000000000 -0400
@@ -0,0 +1,79 @@
+#include <console/console.h>
+#include <stdlib.h>
+#include <string.h>
+#include <device/resource.h>
+#include <device/device.h>
+#include <device/pci.h>
+
+struct cdev {
+	unsigned int devfn;
+	struct cdev *next;
+	struct cdev *children;
+	void *private;
+};
+static struct cdev nodev;
+
+#define DEV(NAME, DEVICE, FUNCTION, NEXT, CHILDREN, PRIVATE) \
+static struct cdev NEXT; \
+static struct cdev CHILDREN; \
+static struct cdev NAME = { \
+	.devfn = PCI_DEVFN(DEVICE, FUNCTION), \
+	.next = &NEXT, \
+	.children = &CHILDREN, \
+ 	.private = PRIVATE, \
+}
+
+DEV(dev0_2_0,  0x02, 0, dev0_1f_0, dev1_1c_0, 0);
+DEV(dev0_1f_0, 0x1f, 0, nodev,     nodev,     0);
+DEV(dev1_1c_0, 0x1c, 0, dev1_1e_0, nodev,     0);
+DEV(dev1_1e_0, 0x1e, 0, nodev,     nodev,     0);
+
+static void add_dev_list(struct device *bus, struct cdev *dev);
+
+static void add_device(struct device *bus, struct cdev *dev)
+{
+	struct device *pdev;
+
+#if 1
+	printk_debug("Adding%s %02x.%01x\n",
+		(dev->children == &nodev)?"":" bus",
+		PCI_SLOT(dev->devfn), PCI_FUNC(dev->devfn));
+#endif
+
+	pdev = malloc(sizeof(*pdev));
+	if (!pdev) 
+		goto no_mem;
+
+	memset(pdev, 0, sizeof(*pdev));
+	pdev->bus = bus;
+	pdev->devfn = dev->devfn;
+
+	/* Add to the list of devices on the parent bus. */
+	pdev->sibling = bus->children;
+	bus->children = pdev;
+
+	/* Add any children we might have */
+	add_dev_list(pdev, dev->children);
+	return;
+ no_mem:
+	printk_err("PCI: out of memory.\n");
+	return;
+}
+
+static void add_dev_list(struct device *bus, struct cdev *dev)
+{
+	while(dev != &nodev) {
+		add_device(bus, dev);
+		dev = dev->next;
+	}
+}
+void enumerate_static_devices(void)
+{
+#if 0
+	struct cdev *dev = &dev0_2_0;
+	add_dev_list(&dev_root, dev);
+#endif
+#if 0
+	dev_root.ops = &default_ht_ops_root;
+#endif
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2880/tyan-fallback.config ../freebios2/src/mainboard/tyan/s2880/tyan-fallback.config
--- ./freebios2/src/mainboard/tyan/s2880/tyan-fallback.config	2003-07-21 16:13:43.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/tyan-fallback.config	2003-07-24 18:01:45.000000000 -0400
@@ -20,7 +20,7 @@
 
 ## Select the maximum size the linuxBIOS code can compile to.
 ## Allow linuxBIOS to be up to 40KB in size
-option ROM_IMAGE_SIZE=40960
+#option ROM_IMAGE_SIZE=40960
 #option ROM_IMAGE_SIZE=38922
 #48K
 #option ROM_IMAGE_SIZE=49152
@@ -30,9 +30,10 @@
 #option ROM_IMAGE_SIZE=41984
 #39K
 #option ROM_IMAGE_SIZE=39936
-
-
-## 
+option ROM_IMAGE_SIZE=65536
+#59k
+#option ROM_IMAGE_SIZE=60416
+ 
 ### The Serial Console
 ##
 ## Hardware flow control is currently ignored.
@@ -72,9 +73,9 @@
 ## SPEW       9   Way too many details             
 
 ## Request this level of debugging output
-option DEFAULT_CONSOLE_LOGLEVEL=8
+option DEFAULT_CONSOLE_LOGLEVEL=7
 ## At a maximum only compile in this level of debugging
-option MAXIMUM_CONSOLE_LOGLEVEL=9
+option MAXIMUM_CONSOLE_LOGLEVEL=8
 
 ## Use the elf bootloader
 option USE_ELF_BOOT=1
diff -uNr ./freebios2/src/mainboard/tyan/s2880/tyan-normal.config ../freebios2/src/mainboard/tyan/s2880/tyan-normal.config
--- ./freebios2/src/mainboard/tyan/s2880/tyan-normal.config	2003-07-21 16:13:44.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/tyan-normal.config	2003-07-24 18:01:35.000000000 -0400
@@ -21,14 +21,15 @@
 
 ## Select the maximum size the linuxBIOS code can compile to.
 ## Allow linuxBIOS to be up to 40KB in size
-option ROM_IMAGE_SIZE=40960
+#option ROM_IMAGE_SIZE=40960
 #option ROM_IMAGE_SIZE=38922
 #option ROM_IMAGE_SIZE=49152
 #option ROM_IMAGE_SIZE=43008
 #41K
 #option ROM_IMAGE_SIZE=41984
 #option ROM_IMAGE_SIZE=39936
-  
+option ROM_IMAGE_SIZE=65536  
+ 
 
 ## 
 ### The Serial Console
@@ -70,9 +71,9 @@
 ## SPEW       9   Way too many details             
 
 ## Request this level of debugging output
-option DEFAULT_CONSOLE_LOGLEVEL=8
+option DEFAULT_CONSOLE_LOGLEVEL=6
 ## At a maximum only compile in this level of debugging
-option MAXIMUM_CONSOLE_LOGLEVEL=9
+option MAXIMUM_CONSOLE_LOGLEVEL=6
 
 ## Use the elf bootloader
 option USE_ELF_BOOT=1
diff -uNr ./freebios2/src/mainboard/tyan/s2880/VERSION ../freebios2/src/mainboard/tyan/s2880/VERSION
--- ./freebios2/src/mainboard/tyan/s2880/VERSION	2003-07-21 16:13:43.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/VERSION	1969-12-31 19:00:00.000000000 -0500
@@ -1 +0,0 @@
-2.0
diff -uNr ./freebios2/src/mainboard/tyan/VERSION ../freebios2/src/mainboard/tyan/VERSION
--- ./freebios2/src/mainboard/tyan/VERSION	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/VERSION	2003-06-13 17:27:51.000000000 -0400
@@ -0,0 +1 @@
+2.0
diff -uNr ./freebios2/src/northbridge/amd/amdk8/coherent_ht.c ../freebios2/src/northbridge/amd/amdk8/coherent_ht.c
--- ./freebios2/src/northbridge/amd/amdk8/coherent_ht.c	2003-07-22 00:12:10.000000000 -0400
+++ ../freebios2/src/northbridge/amd/amdk8/coherent_ht.c	2003-07-24 18:00:24.000000000 -0400
@@ -77,6 +77,41 @@
 	print_debug("done.\r\n");
 
 }
+//BY LYH
+#define WAIT_TIMES 1000
+static void wait_ap_stop(u8 node) 
+{
+	unsigned long reg;
+	unsigned long i;
+	for(i=0;i<WAIT_TIMES;i++) {
+		unsigned long regx;
+		regx = pci_read_config32(NODE_HT(node),0x6c);
+		if((regx & (1<<4))==1) break;
+        }
+	reg = pci_read_config32(NODE_HT(node),0x6c);
+        reg &= ~(1<<4);  // clear it
+        pci_write_config32(NODE_HT(node), 0x6c, reg);
+
+}
+static void notify_bsp_ap_is_stopped(void)
+{
+	unsigned long reg;
+	unsigned long apic_id;
+        apic_id = *((volatile unsigned long *)(APIC_DEFAULT_BASE+APIC_ID));
+	apic_id >>= 24;
+/*      print_debug("applicaton cpu apic_id: ");
+        print_debug_hex32(apic_id);
+        print_debug("\r\n");
+        }*/
+        if(apic_id!=0) { //AP  apic_id == node_id ??
+//              set the ColdResetbit to notify BSP that AP is stopped
+                reg = pci_read_config32(NODE_HT(apic_id), 0x6C);
+                reg |= 1<<4;
+                pci_write_config32(NODE_HT(apic_id),  0x6C, reg);
+        }
+ 
+}
+//BY LYH END
 
 static void enable_routing(u8 node)
 {
@@ -109,8 +144,15 @@
 	print_debug_hex32(node);
 
 	val=pci_read_config32(NODE_HT(node), 0x6c);
-	val &= ~((1<<6)|(1<<5)|(1<<4)|(1<<1)|(1<<0));
-	pci_write_config32(NODE_HT(node), 0x6c, val);
+        val &= ~((1<<6)|(1<<5)|(1<<4)|(1<<1)|(1<<0)); 
+ 	pci_write_config32(NODE_HT(node), 0x6c, val);
+//BY LYH
+#if 1
+	if(node!=0) {
+		wait_ap_stop(node);
+	}
+#endif
+//BY LYH END
 
 	print_debug(" done.\r\n");
 }
@@ -285,9 +327,9 @@
 	/* We found 2 nodes so far */
 	setup_node(0, cpus);	/* Node 1 is there. Setup Node 0 correctly */
 	setup_remote_node(1, cpus);  /* Setup the routes on the remote node */
-	rename_temp_node(1);	/* Rename Node 7 to Node 1  */
-	enable_routing(1);	/* Enable routing on Node 1 */
-	
+        rename_temp_node(1);    /* Rename Node 7 to Node 1  */
+        enable_routing(1);      /* Enable routing on Node 1 */
+  	
 	clear_temp_row(0);	/* delete temporary connection */
 	
 #if MAX_CPUS > 2
@@ -323,14 +365,14 @@
 	
 	setup_temp_row(0,2,cpus);
 	setup_temp_node(2,cpus);
-	rename_temp_node(2);
-	enable_routing(2);
-
+        rename_temp_node(2);
+        enable_routing(2);
+  
 	setup_temp_row(0,1,cpus);
 	setup_temp_row(1,3,cpus);
 	setup_temp_node(3,cpus);
-	rename_temp_node(3);
-	enable_routing(3);	/* enable routing on node 3 (temp.) */
+        rename_temp_node(3);
+        enable_routing(3);      /* enable routing on node 3 (temp.) */
 	
 	clear_temp_row(0);
 	clear_temp_row(1);
@@ -394,6 +436,42 @@
 
 static void coherent_ht_finalize(unsigned cpus)
 {
+//BY LYH 
+#if 1
+     static const unsigned int register_values[] = {
+        PCI_ADDR(0, 0x18, 0, 0x84), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x18, 0, 0xa4), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x18, 0, 0xc4), 0x88ff9c05, 0x770000d0,
+        PCI_ADDR(0, 0x19, 0, 0x84), 0x88ff9c05, 0x770000d0,
+        PCI_ADDR(0, 0x19, 0, 0xa4), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x19, 0, 0xc4), 0x88ff9c05, 0x770000d0,
+
+
+        PCI_ADDR(0, 0x18, 0, 0x88), 0xfffff0ff, 0x00000400,
+        PCI_ADDR(0, 0x18, 0, 0xa8), 0xfffff0ff, 0x00000500,
+        PCI_ADDR(0, 0x18, 0, 0xc8), 0xfffff0ff, 0x00000000,
+        PCI_ADDR(0, 0x19, 0, 0x88), 0xfffff0ff, 0x00000000,
+        PCI_ADDR(0, 0x19, 0, 0xa8), 0xfffff0ff, 0x00000500,
+        PCI_ADDR(0, 0x19, 0, 0xc8), 0xfffff0ff, 0x00000000,
+
+        PCI_ADDR(0, 0x18, 0, 0x94), 0xff0000ff, 0x00ff0000,
+        PCI_ADDR(0, 0x18, 0, 0xb4), 0xff0000ff, 0x00000000,
+        PCI_ADDR(0, 0x18, 0, 0xd4), 0xff0000ff, 0x00000000,
+        PCI_ADDR(0, 0x19, 0, 0x94), 0xff0000ff, 0x00000000,
+        PCI_ADDR(0, 0x19, 0, 0xb4), 0xff0000ff, 0x00000000,
+        PCI_ADDR(0, 0x19, 0, 0xd4), 0xff0000ff, 0x00000000,
+
+      };
+        int i;
+        int max;
+
+
+        device_t dev;
+        unsigned where;
+        unsigned long reg;
+#endif
+//BY LYH END
+
 	int node;
 	bool rev_a0;
 	
@@ -416,7 +494,7 @@
 		pci_write_config32(NODE_HT(node),0x60,val);
 
 		val=pci_read_config32(NODE_HT(node), 0x68);
-		val |= 0x00008000;
+		val |= 0x0f00c800;  // 0x00008000->0f00c800 BY LYH
 		pci_write_config32(NODE_HT(node),0x68,val);
 
 		if (rev_a0) {
@@ -425,6 +503,28 @@
 			pci_write_config32(NODE_HT(node),0xd4,0);
 		}
 	}
+//BY LYH
+#if 1
+        print_debug("setting up coherent ht domain....\r\n");
+        max = sizeof(register_values)/sizeof(register_values[0]);
+        for(i = 0; i < max; i += 3) {
+#if 0
+                print_debug_hex32(i);
+                print_debug(": ");
+                print_debug_hex32(register_values[i]);
+                print_debug(" <-");
+                print_debug_hex32(register_values[i+2]);
+                print_debug("\r\n");
+#endif
+                dev = register_values[i] & ~0xff;
+                where = register_values[i] & 0xff;
+                reg = pci_read_config32(dev, where);
+                reg &= register_values[i+1];
+                reg |= register_values[i+2];
+                pci_write_config32(dev, where, reg);
+        }
+#endif
+//BY LYH END
 
 #if 1
 	print_debug("done\r\n");
diff -uNr ./freebios2/src/northbridge/amd/amdk8/raminit.c ../freebios2/src/northbridge/amd/amdk8/raminit.c
--- ./freebios2/src/northbridge/amd/amdk8/raminit.c	2003-07-22 00:12:11.000000000 -0400
+++ ../freebios2/src/northbridge/amd/amdk8/raminit.c	2003-07-24 18:48:41.000000000 -0400
@@ -1249,7 +1249,14 @@
 		tom |= (1 << (canidate + 24));
 
 		/* Recompute the cs base register value */
-		csbase = (tom << 21) | 1;
+#if 1  // BY LYH  Need to count from 0 for every memory controller
+		csbase = ((tom - (base_k>>15))<< 21) | 1;
+		print_debug("csbase=");
+		print_debug_hex32(csbase);
+		print_debug("\r\n");
+#else  //BY LYH END
+               csbase = (tom << 21) | 1;
+#endif
 
 		/* Increment the top of memory */
 		tom += size;
@@ -1276,6 +1283,14 @@
 	print_debug("\r\n");
 #endif
 	route_dram_accesses(ctrl, base_k, tom_k);
+
+#if 0 //BY LYH
+	if(ctrl->node_id==1) {
+		pci_write_config32(ctrl->f2, DRAM_CSBASE, 0x00000001);
+	
+	}	
+#endif 
+
 	set_top_mem(tom_k);
 }
 
@@ -2224,12 +2239,12 @@
 		print_debug_hex32(dcl);
 		print_debug("\r\n");
 #endif
-#if 1
+#if 0
 		dcl &= ~DCL_DimmEccEn;
 #endif		
 #warning "FIXME set the ECC type to perform"
 #warning "FIXME initialize the scrub registers"
-#if 0
+#if 1
 		if (dcl & DCL_DimmEccEn) {
 			print_debug("ECC enabled\r\n");
 		}
@@ -2260,7 +2275,7 @@
 		} else {
 			print_debug(" done\r\n");
 		}
-#if 0
+#if 1
 		if (dcl & DCL_DimmEccEn) {
 			print_debug("Clearing memory: ");
 			loops = 0;
diff -uNr ./freebios2/src/southbridge/amd/amd8111/Config ../freebios2/src/southbridge/amd/amd8111/Config
--- ./freebios2/src/southbridge/amd/amd8111/Config	2003-05-19 15:16:21.000000000 -0400
+++ ../freebios2/src/southbridge/amd/amd8111/Config	2003-07-24 18:53:08.000000000 -0400
@@ -2,3 +2,4 @@
 driver amd8111_lpc.o
 driver amd8111_ide.o
 driver amd8111_acpi.o
+driver amd8111_usb2.o
diff -uNr ./freebios2/src/southbridge/amd/amd8111/config.lb ../freebios2/src/southbridge/amd/amd8111/config.lb
--- ./freebios2/src/southbridge/amd/amd8111/config.lb	2003-06-17 12:51:05.000000000 -0400
+++ ../freebios2/src/southbridge/amd/amd8111/config.lb	1969-12-31 19:00:00.000000000 -0500
@@ -1,4 +0,0 @@
-driver amd8111_usb.o
-driver amd8111_lpc.o
-driver amd8111_ide.o
-driver amd8111_acpi.o
diff -uNr ./freebios2/src/southbridge/amd/amd8111/Config.lb ../freebios2/src/southbridge/amd/amd8111/Config.lb
--- ./freebios2/src/southbridge/amd/amd8111/Config.lb	2003-06-17 12:51:05.000000000 -0400
+++ ../freebios2/src/southbridge/amd/amd8111/Config.lb	2003-07-24 18:53:27.000000000 -0400
@@ -2,3 +2,4 @@
 driver amd8111_lpc.o
 driver amd8111_ide.o
 driver amd8111_acpi.o
+driver amd8111_usb2.o
diff -uNr ./freebios2/src/southbridge/amd/amd8131/amd8131_bridge.c ../freebios2/src/southbridge/amd/amd8131/amd8131_bridge.c
--- ./freebios2/src/southbridge/amd/amd8131/amd8131_bridge.c	2003-07-22 00:12:51.000000000 -0400
+++ ../freebios2/src/southbridge/amd/amd8131/amd8131_bridge.c	2003-07-22 03:28:44.000000000 -0400
@@ -12,12 +12,11 @@
 	uint16_t word;
 	uint8_t byte;
 
-	
 	/* Enable memory write and invalidate ??? */
 	byte = pci_read_config8(dev, 0x04);
         byte |= 0x10;
         pci_write_config8(dev, 0x04, byte);
-	
+ 	
 	/* Set drive strength */
 	word = pci_read_config16(dev, 0xe0);
         word = 0x0404;
@@ -30,7 +29,7 @@
 	word = pci_read_config16(dev, 0xe8);
         word = 0x0404;
         pci_write_config16(dev, 0xe8, word);
-
+	
 	return;
 }
 
@@ -58,6 +57,14 @@
 		value &= ~((1 << 1) | (1 << 0));
 	}
 	pci_write_config32(dev, 0x44, value);
+
+//BY LYH
+        value = pci_read_config32(dev, 0x4);
+        value |= 6;
+        pci_write_config32(dev, 0x4, value);
+//BY LYH END
+ 
+
 }
 
 static struct device_operations ioapic_ops = {
diff -uNr ./freebios2/targets/tyan/s2880/Config.lb ../freebios2/targets/tyan/s2880/Config.lb
--- ./freebios2/targets/tyan/s2880/Config.lb	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s2880/Config.lb	2003-07-21 21:14:24.000000000 -0400
@@ -0,0 +1,186 @@
+# Sample config file for 
+# the Tyan s2880 
+# This will make a target directory of ./s2880
+
+loadoptions
+
+target s2880
+
+uses AMD8111_DEV
+uses CONFIG_COMPRESS
+uses CONFIG_IOAPIC
+uses CONFIG_ROM_STREAM
+uses CONFIG_ROM_STREAM_START
+uses CONFIG_UDELAY_TSC
+uses CPU_FIXUP
+uses ENABLE_FIXED_AND_VARIABLE_MTRRS
+uses FALLBACK_SIZE
+uses FINAL_MAINBOARD_FIXUP
+uses HAVE_FALLBACK_BOOT
+uses HAVE_MP_TABLE
+uses HAVE_PIRQ_TABLE
+uses i586
+uses i686
+uses INTEL_PPRO_MTRR
+uses HEAP_SIZE
+uses IRQ_SLOT_COUNT
+uses k7
+uses k8
+uses MAINBOARD_PART_NUMBER
+uses MAINBOARD_VENDOR
+uses MAX_CPUS
+uses MEMORY_HOLE
+uses PAYLOAD_SIZE
+uses _RAMBASE
+uses _ROMBASE
+uses ROM_IMAGE_SIZE
+uses ROM_SECTION_OFFSET
+uses ROM_SECTION_SIZE
+uses ROM_SIZE
+uses SIO_BASE
+uses SIO_SYSTEM_CLK_INPUT
+uses STACK_SIZE
+uses USE_ELF_BOOT
+uses USE_FALLBACK_IMAGE
+uses USE_NORMAL_IMAGE
+uses USE_OPTION_TABLE
+uses HAVE_OPTION_TABLE
+
+option HAVE_OPTION_TABLE=1
+option HAVE_MP_TABLE=1
+option CPU_FIXUP=1
+option CONFIG_UDELAY_TSC=0
+option i686=1
+option i586=1
+option INTEL_PPRO_MTRR=1
+option k7=1
+option k8=1
+option ROM_SIZE=524288
+
+### Customize our winbond superio chip for this motherboard
+###
+option SIO_BASE=0x2e
+option SIO_SYSTEM_CLK_INPUT=0
+#
+###
+### Build code to export a programmable irq routing table
+###
+option HAVE_PIRQ_TABLE=1
+option IRQ_SLOT_COUNT=13
+#
+###
+### Build code for SMP support
+### Only worry about 2 micro processors
+###
+option CONFIG_SMP=1
+option MAX_CPUS=2
+#
+###
+### Build code to setup a generic IOAPIC
+###
+option CONFIG_IOAPIC=1
+#
+###
+### MEMORY_HOLE instructs earlymtrr.inc to
+### enable caching from 0-640KB and to disable 
+### caching from 640KB-1MB using fixed MTRRs 
+###
+### Enabling this option breaks SMP because secondary
+### CPU identification depends on only variable MTRRs
+### being enabled.
+###
+option MEMORY_HOLE=0
+#
+###
+### Enable both fixed and variable MTRRS
+### When we setup MTRRs in mtrr.c  
+###
+### We must setup the fixed mtrrs or we confuse SMP secondary
+### processor identification
+###
+option ENABLE_FIXED_AND_VARIABLE_MTRRS=1
+#
+###
+### Clean up the motherboard id strings
+###
+#option MAINBOARD_PART_NUMBER="Solo7"
+#option MAINBOARD_VENDOR="AMD"
+#
+###
+### Call the final_mainboard_fixup function
+###
+option FINAL_MAINBOARD_FIXUP=1
+
+###
+### Compute the location and size of where this firmware image
+### (linuxBIOS plus bootloader) will live in the boot rom chip.
+###
+#option FALLBACK_SIZE=524288
+###
+### Compute where this copy of linuxBIOS will start in the boot rom
+###
+#
+###
+### Compute a range of ROM that can cached to speed up linuxBIOS,
+### execution speed.
+###
+##expr XIP_ROM_SIZE = 65536
+##expr XIP_ROM_BASE = _ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE
+##option XIP_ROM_SIZE=65536
+##option XIP_ROM_BASE=0xffff0000
+#
+## XIP_ROM_SIZE && XIP_ROM_BASE values that work.
+##option XIP_ROM_SIZE=0x8000
+##option XIP_ROM_BASE=0xffff8000
+
+## We don't use compressed image
+option CONFIG_COMPRESS=0
+
+option USE_ELF_BOOT=1
+
+## ROM_IMAGE_SIZE is the amount of space to allow linuxBIOS to occupy.
+option ROM_IMAGE_SIZE=49152
+
+## LinuxBIOS C code runs at this location in RAM
+option _RAMBASE=0x00100000
+
+##
+## Use a 64K stack
+##
+option STACK_SIZE=0x10000
+
+##
+## Use a 64K heap
+##
+option HEAP_SIZE=0x10000
+
+#
+###
+### Compute the start location and size size of
+### The linuxBIOS bootloader.
+###
+option PAYLOAD_SIZE            = (ROM_SECTION_SIZE - ROM_IMAGE_SIZE)
+option CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+option CONFIG_ROM_STREAM     = 1
+option _ROMBASE      = (CONFIG_ROM_STREAM_START + PAYLOAD_SIZE)
+
+#
+# Arima hdama
+romimage "normal"
+	option USE_FALLBACK_IMAGE=0
+	option ROM_SECTION_SIZE  = (ROM_SIZE - FALLBACK_SIZE)
+	option ROM_SECTION_OFFSET= 0
+	mainboard arima/hdama
+	payload ../eepro100.ebi 
+end
+
+romimage "fallback" 
+	option USE_FALLBACK_IMAGE=1
+	option HAVE_FALLBACK_BOOT=1
+	option ROM_SECTION_SIZE  = FALLBACK_SIZE
+	option ROM_SECTION_OFFSET= (ROM_SIZE - FALLBACK_SIZE)
+	mainboard arima/hdama
+	payload ../eepro100.ebi 
+end
+
+buildrom ROM_SIZE "normal" "fallback"
